/* gnuserv.h	-- peter
 *
 * $Header: /cygdrive/h/REPOSITORY/gnuserv/gnuserv.h,v 1.1.1.1 2001/10/24 01:32:02 unknown Exp $
 * $Log: gnuserv.h,v $
 * Revision 1.1.1.1  2001/10/24 01:32:02  unknown
 *
 *
 * Revision 1.1.1.1  2001/10/24 00:32:01  Hugo
 * no message
 *
 * Revision 1.2  2001/07/10 12:01:08  anonymous
 * * added option -a to gnuclient (use alternate editor; defined as Notepad)
 * * some code cleanup to have more control over starting emacs or not
 *
 * Revision 1.1.1.1  2001/07/10 10:28:50  anonymous
 * no message
 *
 */

#ifndef _GNUSERV_H
#define _GNUSERV_H

#include <windows.h>
#include <stdio.h>

#undef  GNUSERV_DEBUG

#define MAXPATHLEN  400
#define GSERV_BUFSZ 1000

#define EOT_STR     "\004"
#define EOT_CHR     '\004'

//
// The %s will be replaced by the host name or "." for localhost.
// The %08x will be replaced by the client-ID.
//
#define GNUSERV_SEND_MAILSLOT      "\\\\%s\\mailslot\\emacs\\gnuserv"
#define GNUSERV_RECEIVE_MAILSLOT   "\\\\.\\mailslot\\emacs\\gnuserv"
#define GNUSERV_SEND_CLIENTSLOT    "\\\\%s\\mailslot\\emacs\\gnuclient\\%08x"
#define GNUSERV_RECEIVE_CLIENTSLOT "\\\\.\\mailslot\\emacs\\gnuclient\\%08x"
#define GNUSERV_DEFAULT_HOST       "."

//
// Function prototypes
//
HANDLE CreateGnuServSlot (BOOL clientslot, DWORD clientid);
HANDLE ConnectToMailslot (char *host, BOOL clientslot, DWORD clientid);
void   DisconnectFromMailslot (HANDLE slot);
int    SendString (HANDLE slot, const char *msg);
void   WaitForServerResult (HANDLE slot, BOOL echo);
BOOL   IsWindowsNT (void);
void   OutputErrorString (char *errormsg);

void initGnuClient(int auto_start_emacs, int connection_retries);

#endif
