/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000
// Ralf Westram
// Time-stamp: <Tue Jul/10/2001 15:10 MET Coder@ReallySoft.de>
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.  Ralf Westram makes no
// representations about the suitability of this software for any
// purpose.  It is provided "as is" without express or implied warranty.
//
/////////////////////////////////////////////////////////////////////////////

#ifndef CONFIG_H
#define CONFIG_H

// --------------------------------------------------------------------------------

#define TRY_TO_START_EMACS 1 // should gnuclient try to start emacs?
// Note: starting emacs only makes sense, if emacs automatically starts gnuserv

// Command used to start emacs:
#if defined(MY_SPECIAL_EMACS_CALL)
#define RUNEMACS "C:\\Programme\\AutoMate4\\runtask.exe \"Start hidden XEmacs\""
#else
#define RUNEMACS "runemacs.exe"
#endif

#define ALTERNATE_EDITOR_WAIT "start.exe /wait Notepad.exe"
#define ALTERNATE_EDITOR_NOWAIT "Notepad.exe"

#if (TRY_TO_START_EMACS != 0)
#define RETRY_CONNECT_GNUSERV 60 // How many times should we retry to connect to gnuserv
// Note: it's done with pauses of 1 second
//       if TRY_TO_START_EMACS == 1 a higher value (about 30 or 60) is recommended in order to give emacs a change of coming up
//       otherwise it will (normally) only delay the error message (so a lower value is recommended)
#else
#define RETRY_CONNECT_GNUSERV 3
#endif

// --------------------------------------------------------------------------------

#else
#error config.h included twice
#endif // CONFIG_H
