
(defun exit-hook-xemacs-w32 ()
  "kill-emacs-hook to stop gnuserv"
  (interactive)
  (gnuserv-quit)        
  (sleep-for 3);; wait till gnuserv shuts down (otherwise emacs won't terminate)
  )            

(defun exit-emacs-win32 ();; exit w/o ask
  "exit emacs (save everything changed - don't ask)"
  (interactive)
  (save-buffers-kill-emacs 't)
  )

(defun init-emacs-win32 ()
  "initialize my emacs for win32"
  (interactive)
  
  (load "gnuserv")
  (setq-default server-ask-when-reverting 't)

  (switch-to-buffer "*server*")
  (gnuserv-start)
            
  (add-hook 'kill-emacs-hook 'exit-hook-xemacs-w32)
            
  (global-unset-key "\C-x\C-c")
  (global-set-key "\C-x\C-c" 'exit-emacs-win32)
  
  )

;; put the following command into your .emacs or whereever you want
;; (init-emacs-win32)
